/*
 *       SmoothAlgorithms.mqh
 *  : __\MQL5\Include
 */
//+------------------------------------------------------------------+ 
//|                                                        JMACD.mq5 | 
//|                               Copyright  2010, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   2
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1 DRAW_HISTOGRAM
//----     MACD   - 
#property indicator_color1 BlueViolet
//----   -  
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "JMACD"

//----     
#property indicator_type2 DRAW_LINE
//----        
#property indicator_color2 Magenta
//----   -  
#property indicator_style2 STYLE_DASHDOTDOT
//----     1
#property indicator_width2 2
//----    
#property indicator_label2  "Signal Line"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //PRICE_CLOSE
   PRICE_OPEN_,          //PRICE_OPEN
   PRICE_HIGH_,          //PRICE_HIGH
   PRICE_LOW_,           //PRICE_LOW
   PRICE_MEDIAN_,        //PRICE_MEDIAN
   PRICE_TYPICAL_,       //PRICE_TYPICAL
   PRICE_WEIGHTED_,      //PRICE_WEIGHTED
   PRICE_SIMPL_,         //PRICE_SIMPL_
   PRICE_QUARTER_,       //PRICE_QUARTER_
   PRICE_TRENDFOLLOW0_, //PRICE_TRENDFOLLOW0_
   PRICE_TRENDFOLLOW1_  //PRICE_TRENDFOLLOW1_
  };
input int Fast_JMA = 12; //  
input int Slow_JMA = 26; //  SMMA 
input int Signal_JMA= 9; //   
input int Phase_=100;    // ,
                         //   -100 ... +100,
//    ;
input Applied_price_ AppliedPrice=PRICE_CLOSE_; // ,
/*      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPLE, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */
//+-----------------------------------+
//---- e 
double MACDBuffer[],SignBuffer[];

int start=60,macd_start=30;
//+------------------------------------------------------------------+
//   iPriceSeries                                     |
//   CJJMA                                             |
//+------------------------------------------------------------------+  
#include <SmoothAlgorithms.mqh>  
//+------------------------------------------------------------------+    
//| JMACD indicator initialization function                          | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----    MACDBuffer   
   SetIndexBuffer(0,MACDBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,macd_start+1);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"JMACD");
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    SignBuffer   
   SetIndexBuffer(1,SignBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,start+1);
//---      DataWindow
   PlotIndexSetString(1,PLOT_LABEL,"Signal JMA");
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   string shortname;
   StringConcatenate(shortname,"JMACD( ",Fast_JMA,", ",Slow_JMA,", ",Signal_JMA," )");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//----       
   JMA.JJMALengthCheck("Fast_JMA", Fast_JMA);
   JMA.JJMALengthCheck("Slow_JMA", Slow_JMA);
   JMA.JJMALengthCheck("Slow_JMA", Signal_JMA);
//----       
   JMA.JJMAPhaseCheck("Phase_",Phase_);
//----  
  }
//+------------------------------------------------------------------+  
//| MACD iteration function                                          | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<start) return(0);

//----   
   int first,bar;
//----       
   double price_,fast_jma,slow_jma,jmacd,sign_jma;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      

      //----      
      for(bar = 0; bar <= macd_start; bar++) MACDBuffer[bar] = 0.0;
      for(bar = 0; bar <= start;      bar++) SignBuffer[bar] = 0.0;
     }
   else first=prev_calculated-1; //      

//----    JJMA   JJMASeries_Cls.mqh
   static CJJMA JMA1,JMA2,JMA3;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      price_=PriceSeries(AppliedPrice,bar,open,low,high,close);;

      fast_jma = JMA1.JJMASeries(0, prev_calculated, rates_total, 0, Phase_, Fast_JMA, price_, bar, false);
      slow_jma = JMA2.JJMASeries(0, prev_calculated, rates_total, 0, Phase_, Slow_JMA, price_, bar, false);

      jmacd=fast_jma-slow_jma;

      sign_jma=JMA3.JJMASeries(macd_start,prev_calculated,rates_total,0,Phase_,Signal_JMA,jmacd,bar,false);

      //----            
      MACDBuffer[bar] = jmacd;
      SignBuffer[bar] = sign_jma;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
